## Aims { data-transition="fade none" }

<div style="text-align:left; font-size:x-large">At the end of this lecture, the student should be able to:</div>
* Begin authoring computer programs using the Haskell programming language syntax
* Become familiar with the workflow and tooling, associated with writing Haskell programs

<aside class="notes">
  * values, assignment
  * type signatures `::` reads as *has the type*
    * The `->` in a type signature is *right-associative*
  * functions are values
  * functions take arguments
    * functions take *only one argument* but we approximate with spoken
      language
    * functions can be declared inline using *lambda expressions*
    * the `\` symbol in a lambda expression denotes a Greek lambda
  * operators, beginning with non-alpha character, are in infix position by
    default
    * use in prefix position by surrounding with *(parentheses)*
  * regular identifiers, beginning with alpha character, are in prefix position by
    default
    * use in infix position by surrounding with ``backticks``
  * polymorphism
    * type variables *always* start with a lower-case character
  * data types, declared using the `data` keyword
    * following the `data` keyword is the *data type name*
    * following the data type name are zero of more type variables
    * then `=` sign
    * data types have zero or more constructors
      * data type constructors start with an upper-case character, or colon `(:)`
    * following each constructor is a list of zero or more *constructor arguments*
    * between each constructor is a pipe symbol `(|)`
    * the `deriving` keyword gives us default implementations for some functions
      on that data type
    * when constructors appear on the left side of `=` we are *pattern-matching*
    * when constructors appear on the right side of `=` we are *constructing*
  * type-classes
</aside>

---

